// magicSquare.cpp  Michael J. Chappell  23 January 2010
// version 2.0                           21 October 2017
// version 2.1                           22 February 2020
// version 2.2                           05 December 2022
// version 2.3                           08 December 2022

// Implementation of Magic Squares from Merlin

#include <iostream>
using namespace std;
#include <curses.h>

#include <cstdlib>

#if defined(__NetBSD__)
#include <unistd.h>
#endif

#include "magicsquare.h"
int toggle[] = {0, TOG1, TOG2, TOG3, TOG4, TOG5, TOG6, TOG7, TOG8, TOG9};

int main(int argc, char **argv) {
  int board = 0;
  int again = 1;
  int t = 0;
  int count = 0;

#if defined(__APPLE__)
  srandomdev();
#elif defined(__NetBSD__)
  srandom(getpid());
#else
  srandom(clock());
#endif

  initscr(); cbreak(); noecho(); curs_set(0);

  while(again) {
    board = init(argc, argv);
    showboard(board);
    count = 0;
    do {
      t = getnum(9);
      if (!t) {
	break;
      } else {
	board ^= toggle[t];
	showboard(board);
	count++;
      }
    } while (board != WINNER);
    if (board == WINNER) {
      winner(count);
    } else {
      quitter();
    }
    playagain();
    again = getnum(1);
  }
  curs_set(1); echo(); endwin();
} // main

int init(int argc, char **argv) {
  int q = 0;

  q = ((random()%511)+WINNER+1)%511;

  return q;
}
